#include <Adafruit_WS2801.h>
#include <SPI.h>
#include <Time.h>
#include <TimeLib.h>
#include <NtpClientLib.h>
#include <ESP8266WiFi.h>
#include <DNSServer.h>  
#include <ESP8266WebServer.h>     
#include <WiFiManager.h>  

volatile bool use_seconds = true;
volatile unsigned long time_saved=0, debounce_time=2000;


uint8_t buttonPin1      = D4;
uint8_t buttonPin2      = D3;
uint8_t dataPinStrip    = D6;
uint8_t clckPinStrip    = D7;
uint8_t num_LEDs        = 6;
uint32_t c              = 0;
Adafruit_WS2801 strip = Adafruit_WS2801(num_LEDs, dataPinStrip, clckPinStrip);
uint32_t Color(uint8_t r, uint8_t g, uint8_t b)
{
    return ((((r << 8) | g) << 8) | b);
}

void display_binary(int h, int m, int s=0) {
    if(!use_seconds){s=0;}
    for (int i = num_LEDs-1; i >= 0; --i)
       {
        uint8_t b = (((h >> i) & 0x1) == 1) ? 250 : 0;
        uint8_t r = (((m >> i) & 0x1) == 1) ? 250 : 0;
        uint8_t g = (((s >> i) & 0x1) == 1) ? 250 : 0;
        //c = Color(i, r, g, b);
        strip.setPixelColor(i, r, g, b);
    }
    strip.show();
}

void setup()
{	
  attachInterrupt(digitalPinToInterrupt(buttonPin1), on_button_pressed, HIGH);
  pinMode(buttonPin1,INPUT_PULLUP);
  digitalWrite(buttonPin1, LOW);
	strip.begin();
  Serial.begin(115200);
  WiFiManager wifiManager; // wifi configuration wizard
  wifiManager.autoConnect("uNmOment", ""); // configuration for the access point, set your own secret. 
  Serial.println("WiFi Client connected!)");
  NTP.begin("es.pool.ntp.org", 1, true); // get time from NTP server pool.
  NTP.setInterval(63);
}

void on_button_pressed()
{
    if((millis() - time_saved) > debounce_time) 
    { 
        use_seconds = !use_seconds;
        Serial.println("Button gedrückt");
        Serial.print("use_seconds:");
        Serial.print(use_seconds);
        Serial.print('\n');
        time_saved = millis();
    }    
}

void loop()
{
	static int i = 0;
	static int last = 0;
  
		last = millis();
		Serial.print(i); Serial.print(" ");
		Serial.print(NTP.getTimeDateString()); Serial.print(" ");
		Serial.print(NTP.isSummerTime() ? "Summer Time. " : "Winter Time. ");
		Serial.print("WiFi is ");
		Serial.print(WiFi.isConnected() ? "connected" : "not connected"); Serial.print(". ");
		Serial.print("Uptime: ");
		Serial.print(NTP.getUptimeString()); Serial.print(" since ");
		Serial.println(NTP.getTimeDateString(NTP.getFirstSync()).c_str());
  time_t t = now();
    display_binary(hour(t), minute(t), second(t));
    i++;
    if(use_seconds)
    {
    delay(1000);
    }
    else
    {
    delay(60000);
    }
}
